#!/usr/bin/perl 

   use Template;

   require "../configs/s.pl";
   require "$include_dir/msg.pl";
   require "$include_dir/tools.pl";
   require "$include_dir/parse.pl";
   require "$include_dir/se_utils.pl";
   require "../configs/permanent.pl";
   require "$include_dir/debug.pl";
   require "$include_dir/misc.pl";
   require "$include_dir/recent.pl";
   require "$include_dir/gb.pl";

   # require "../configs/cosmetics.pl";

   $include_path = $tt_dir;

   $t1 = time;
   srand ($t1 ^ $$);
   my $ref = &get_referer ();

   &report_user ($ref) if ($ref ne '');
   &decode_vars;     

   $p = &get_path ();
   $url = &get_url ();
   $page = $FORM{'page'};

   if ($path_length > 0) { $field = $path[0]; }
  
   &run_parse;       
   
   &process_getfile;       
   &process_act_main;          
   &relocate_if_need;

   if ($p eq '' && $to_show[0] eq '') { 
      if ($default_path) {
         $FORM{'path'} = $default_path;
         &init_path;
         $p = &get_path();
         $url = &get_url();
         &run_parse;
      }
      else {
         print "Location: http://$SITE_IP/$front_page"."$default_action\n\n";
         exit 0;
      }
   }

    my ($fname, $dir, $gb_name_data) = &get_index_file_n_gb ($last_hash);
    my $template = Template->new ({
                   INCLUDE_PATH  => "$include_path",
                   RELATIVE => 1,        
                   ABSOLUTE => 1,
                   PRE_PROCESS => "$include_path/config",
    });

    my $lin_ = &get_path(-1);

    my $vars = {
        'main_list'     => \@MAIN_LIST,
        'top_item'      => $top_item,
        'last_item'     => $last_item,
        'last_hash'     => $last_hash,
        'path'          => $p,
        'url'           => $url,
        'SITE_IP'       => $SITE_IP,
        'index'         => $index,
        'field'         => $field,
        'sub'           => $sub,
        'print_msg'     => $MSG{'to_print'},
        'page'          => $page,
        'left_nav'      => &get_left_nav(),
        'getfile_name'  => defined $FORM{'get'} ? 
                               $GETFILE_NAMES{$FORM{'get'}} : undef,
        'text'          => &get_main_text ($fname, $dir), 
        'common_1'      => &get_common (1),
        'common_2'      => &get_common (2),
        'lin_'          => $lin_,
        'recent'        => &get_recent_list(),
        'css'           => &get_css(),
        'FORM'          => \%FORM,

        'add_nav'       => &get_add_nav(),
        'pages'         => &get_pages(),

#        'wiki_link'     => &get_wiki_link(),
        'gb_body'       => &get_guestbook ($index, "user",
                                           $gb_name_data, undef),
        'print_link'    => &get_print_link(),
                };

    my $ttt;
    my $to_print = $FORM{'print'};	      

    if (!$to_print) {
       $ttt = $tt_default;

       if (defined $last_hash->{'TT'} && 
           $last_hash->{'TT'} ne '' &&
           $last_hash->{'TT'} ne 'NONE') {
           $ttt = $last_hash->{'TT'};
       }
    } else {
       $ttt = $tt_print_defailt;
       if (defined $last_hash->{'TT_PRINT'} && 
           $last_hash->{'TT_PRINT'} ne '' &&
           $last_hash->{'TT_PRINT'} ne 'NONE') {
          $ttt = $last_hash->{'TT_PRINT'};
       }
     }
       
    print "Content-type: text/html\n\n";
    $template->process ($ttt, $vars)
              ||  die $template->error(), "\n";

    $t2 = time;

    exit ;

