{
'success';

} 

###########################################################################
sub edit_sub {
###########################################################################
  my $changed = 0;
  my $is_top = ($sub == -1);
  my $coding_table = {};
  my @desc;
  my $hint;
  my $line;
  my $key;
  my $kk;

  $coding_table = &out_in_table;
 
 while (($key,$content) = each %$coding_table) {
    if (defined $FORM{$key}) {
       $val= $FORM{$key};
       $val=~s/\&quot;/"/gs;
       $val=~s/\n//gs;
       $val=~s/\r//gs;
       $val=~s/\t/ /gs;
       $val=~s/\+/ /gs;
       $val=~s/
//gs;
       $val=~s/\;/\,/gs;
       $val=~s/\=/\-/gs;

       if ($key eq 'file' || $key eq 'gb_name'
           || $key eq 'des_file' || $key eq 'key_name'
           || $key eq 'css' || $key eq 'email') { 
          $val =~ s/ //gs; 
       }

       if ($content eq 'NAME') {
          $f_name = $val;
       }
       elsif ($val ne '')  {
          $last_hash->{$content} = $val; 
       }

    }
 }

 # check-in boxes
 $last_hash->{'GB_OFF'} = 0 if (!defined  $FORM{'gb_off'});
 $last_hash->{'NEWS_ON'} = 0 if (!defined  $FORM{'news_on'});
 $last_hash->{'ACTIVE'} = 0 if (!defined  $FORM{'active'});

 $coding_table = &in_out_table;

 while (($key,$content) = each %$last_hash) {
    $k = '';
    $k = $coding_table->{$key} if (defined $coding_table->{$key});

    if ($k ne '') {
       $fin_list = join (';', $fin_list, "$k=$content");
    }
 }

 if ($is_top) {
    $fin_list = join (';', $fin_list, "number=$field");
    $fin_list = "field_name=$f_name;$fin_list";
    $file_to = $fields_file;
    $key = ";number=$field";
    $kk = $field;
 }
 else {
    $fin_list = join (';', $fin_list, "sub=$sub");
    $fin_list = "sub_name=$f_name;$fin_list";
    $file_to = ${$last_item->{'UP_HASH'}}{'DESC_FILE'};
    $key = ";sub=$sub";
    $kk = $sub;
 }

  &error ("", "Cannot reach material file for $p") if ($file_to eq '');
  &error ("bad_data", "field number  is negative") if ($kk == -1);

 $fin_list =~s/;;/;/gs;
 $fin_list =~s/\n//gs;
 $fin_list =~s/\r//gs;

 open (DATA, "$start_path/$data_dir/$file_to");
 @desc = <DATA>;
 close DATA;

 open (DATA, ">$start_path/$data_dir/$file_to");
 flock(DATA, LOCK_EX);

 foreach $line (@desc) {
    my $field = '';

    if ($line ne '' && !($line=~ /^\#/)) {
      $field = &parse_one_line ($is_top, $line);

      if (defined $field->{'KEY'}  &&
          $field->{'KEY'} ne $kk &&  $field->{'KEY'} > -1) {
         print DATA $line, "\n" if ($line ne '');
      }
      else {
         if (defined $field->{'KEY'} && $field->{'KEY'} > -1) { 
           print DATA $fin_list, "\n";
           &report ("editing $file_to for $p, key= $field->{'KEY'}");
         }
      }
    }
 }

 flock(DATA, LOCK_UN);
 close DATA;

 print "Location: $cp\n\n";
 exit 0;

}

###########################################################################
sub f_delete {
###########################################################################
  my $file = '';
  my $line = '';
  my @desc = ();
  my $key;
  my $pp = &get_path(-1);
  my $is_top = ($sub == -1);
  my $up_hash = {};
  my $file_to;
  my $kk = '';

  if (!$is_top) {
     $up_hash = $last_item->{'UP_HASH'};
     $file_to = $up_hash->{'DESC_FILE'};     

     $key = ";sub=$sub";
     $kk = $sub; 
  } 
  else {
     $file_to = $fields_file;     
     $key = ";number=$field";
     $kk = $field;
  }  
  
  $file = "$start_path/$data_dir/$file_to";
  &error ("bad_data", "$file_to doesn't exists") if (! -e $file || -d $file);
  &report(" deleting in file : $file_to");
  &error ("bad_data", "field number  is negative") if ($kk == -1);

  open (DATA, "$file") ;
  @desc = <DATA>;
  close DATA;

  open (DATA, ">$file") ;
  flock(DATA, LOCK_EX);

  my $done = 0;

  foreach $line (@desc) {
    if ($line ne '' && !($line=~ /^\#/)) {
     my $field = &parse_one_line ($is_top, $line);

     if (defined $field && defined $field->{'KEY'} && 
         $field->{'KEY'} ne $kk && $field->{'KEY'} > -1) {
        print DATA $line, "\n";
     }
     else {
        if ($field->{'KEY'} > -1 
            && $field->{'KEY'} == $kk 
            && !$done) {
           $done = 1;
           &report("erasing record : $p for $field->{'KEY'}");
        }
     }
    }
  }

  flock(DATA, LOCK_UN);
  close DATA;

  print "Location: http://$SITE_IP/$cpanel/$pp\n\n";
  exit 0;
}
 
###########################################################################
sub add_sub {
###########################################################################
 my $p_from = shift;
 my $nn;
 my $val;
 my $fin_list;
 my $key;
 my $content;
 my $pp = $p;
 my $file_pattern;
 my $is_top = ($field == -1);
 my $coding_table;
 my $k;
 my $file_to;
 my $items;
 my $it;
 my $from_it;
 my $from_hash;

 if (defined $p_from && !$p_from && $p_from ne '' &&
     $p_from ne "/") {

    my @ppp = &fix_path($p_from);
    my @from = &parse_path ($p_from, @ppp);

    $from_it = $from[0];
    my $count = scalar @from;
    if ($count) {
        $from_it = $from[$count-1];
        $from_hash = $from_it->{"HASH"} if ($from_it);
    }
 }

 $coding_table = &in_out_table ($is_top);
 
 if (!$is_top) {
    $coding_table->{'PAGES'} = 'pages';
 }

 $nn = $n_sub_ch;
 $pp =~s/\//\_/gs; 

 if (!$is_top) {
    $items = $last_item->{'DOWN_LIST'};
    $file_pattern =  "sub_$pp";
 }
 else {
   $items = $last_item->{'UP_LIST'};
   $file_pattern =  "des";
 }

 $nn = 0;

 foreach $it (@$items) {
   $nn = $it->{'KEY'} if ($it->{'KEY'} > $nn);
 }

 $nn++;

 if ($is_top) {
    $ii = "index_".$nn.".html";
 }
 else {
    $ii = $file_pattern."_$nn.html";
 }
 

 while ($nn <= $last_item->{'HAS_CH'} || 
        -e "$start_path/$data_dir/$file_pattern"."_$nn.des" ||
        -e "$field_dir_base/$field_dir/$ii") {
   $nn++;

   if ($is_top) {
      $ii = "index_".$nn.".html";
   }
   else {
      $ii = $file_pattern."_$nn.html";
   }
 }

 $new_field = &init_field ($is_top);
 $new_field->{'DESC_FILE'} = $file_pattern."_$nn.des";

 if ($is_top) {
    $field = $nn;
 }
 else {
    $sub = $nn;
 }

 $new_field->{'INDEX_FILE'} = $ii;
 
 while (($key,$content) = each %$new_field) {
    if (defined ${$coding_table}{$key}) {
       $k = ${$coding_table}{$key};
       $fin_list = join (';', "$k=$content", $fin_list );        
    }
 }

 if ($is_top) {
    $fin_list = join (';', $fin_list, "number=$field");
    $fin_list = "field_name=;$fin_list";
    $file_to = $fields_file;
 }
 else {
    $fin_list = join (';', $fin_list, "sub=$sub");
    $fin_list = "sub_name=;$fin_list";
    $file_to = $last_hash->{'DESC_FILE'};
    $file_to = $file_pattern.".des" if ($file_to eq '');
 }

 &include_file ("debug.pl");
 &error ("", "File for $p/$nn is empty") 
        if ($file_to eq '');

 $fin_list =~s/;;/;/gs;
 $fin_list =~s/\n//gs;
 $fin_list =~s/\r//gs;

 open (DATA, ">>$start_path/$data_dir/$file_to");
 flock(DATA, LOCK_EX);

 print DATA $fin_list, "\n";
 
 flock(DATA, LOCK_UN);
 close DATA;

 &report("$MSG{'s_a1'}: $p/$nn to $file_to ");
 print "Location: $cp/$nn\n\n";

 if ($is_top) {
    my $permissions = oct("0777");

    $field_dir = "dir_$field";
    mkdir ("$field_dir_base/$field_dir", $permissions) || 
          &error (bad_data, "$!");
 }

 exit 0;
}

###########################################################################
sub get_pages {
###########################################################################

  my @res = undef;

  if ($last_hash->{'PAGES'} eq '' || 
      $last_hash->{'PAGES'} <= 0 ||
      $last_hash->{'PAGES'} eq '0' ) {

     return undef;
  }

  my $count = 0;

  while ($count ne $last_hash->{'PAGES'}) {

    push @res, $count;
    $count++;
  }

  return \@res;
}
