#!/usr/local/bin/perl
{

 'success';

}

###########################################################################
sub get_item_data {
###########################################################################
  my ($path, $item, $dir, $color, $cosm, $index) = @_;
  my $msg;
  my @tmp = ();
  my $cnt = $path;
  my $add_info = '';
  my $a_font = "<font color=$color>";
  my $b_font = "</font>";

  push @tmp, "\n<p><li> ";

  if (!$item || !defined $item) {
     return @tmp;
  }

  $msg = $item->{'NAME'};

  if ($msg eq '') {
     $msg = $cnt;
  }

  if ($cosm) {
     $a_font = $b_font = "";
  }

  push @tmp, "<a href=http://$SITE_IP/$index/$path>$a_font".$msg."$b_font</a>\n";

  if ($item->{'DESC'} && $cosm && 
      $item->{'DESC'} ne ' ' 
      && $item->{'DESC'} ne '') {
     push @tmp, "<br>$item->{'DESC'}\n";
  }

  $add_info = &get_gb_file_info ($item->{'GB_NAME'}, $item->{'INDEX_FILE'}, $dir) if ($cosm);

  if ($add_info ne '' && $cosm) {
     push @tmp, "<br><font color=gray size=-2>$add_info</font>\n";
  }

  return @tmp;
}

###########################################################################
sub get_cp_data {
###########################################################################
  my ($path, $item, $dir, $color, $cosm, $index) = @_;
  my $msg;
  my @tmp = ();
  my $cnt = $path;
  my $add_info = '';
  my $a_font = "<font color=$color>";
  my $b_font = "</font>";

 # push @tmp, "\n<br><li> ";

  if (!$item || !defined $item) {
     return @tmp;
  }

  $msg = $item->{'NAME'};

  if ($msg eq '') {
     $msg = $cnt;
  }

  push @tmp, "<a href=http://$SITE_IP/$index/$path>$a_font".$msg."$b_font</a>";
  push @tmp, " <font color=red>HIDEN</font>" if ($item->{'ACTIVE'} != 1);
  push @tmp, "\n";

  return @tmp;
}
 
###########################################################################
sub process_keys_1 {
###########################################################################
  my ($p, $fields_dir, $des_file)  = @_;
  my $top;
  my $it;
  my @tmp = ();
  my $key;
  my $desfile;
  my $path;

  if (!$des_file  || $des_file eq '') {
   return;
  }

  my $name = "$start_path/$data_dir/$des_file";

  if (! -e $name ) {
     return;
  }


  if ($p ne ''){
     $top = -1;
  }
  else {
     $top = 1;
  }

  my @items = &parse_fields_file ($top, $des_file);

  line: foreach $it (@items) {
     next line if ($it->{'ACTIVE'} != 1);
     next line if ($it->{'NAV'} eq 'YES');

     $key = $it->{'KEY'};

     if ($top > 0) {
        $path = $key;
     }
     else {
        $path = "$p/$key";
     }

     &fix_field ($it, $path, ($top > 0), 0);
     $fields_dir = "dir_$key" if ($top > 0);
     @tmp = (@tmp, &get_item_data($path, $it, $fields_dir, $linkcolor, 1, $front_page));

     $desfile = $it->{"DESC_FILE"};
     $name  = "$start_path/$data_dir/$desfile";

     if (-e $name && !-d $name && $it->{'NAV'} ne 'CHILDREN') {
        @tmp = (@tmp, "<ul>\n", &process_keys_1 ($path, $fields_dir, $desfile), "</ul>\n");
     }
  }   


  return @tmp;
}

###########################################################################
sub process_tree {
###########################################################################
   my @tmp = ();

   &include_file ("gb.pl");

   push @tmp, "<ul>\n";
   @tmp = (@tmp, &process_keys_1 ("", "", $fields_file));
   push @tmp, "</ul><br>\n";

   return @tmp;
}

###########################################################################
sub do_search {
###########################################################################
   my @tmp = ();
   my $t = '';
   my $set = '';
   my $cnt = 0;
   $query = shift;
   my $f_n = '';
   my $hits = '';

   &include_file ("gb.pl");
   push @tmp, "<strong>$MSG{'001'}</strong> \"$query\"<br>\n<strong>$MSG{'002'}</strong><p><ul>\n";
   @tmp = (@tmp, &process_keys_search ("", $fields_file, "")); 
   return @tmp;
}

###########################################################################
sub visit_all {
###########################################################################
  my ($p, $des_file, $fields_dir) = @_;

  my @tmp = ();
  my @keys = ();
  my $key;
  my $top;
  my $it;
  my $desfile;
  my $path;

  if (!$des_file  || $des_file eq '') {return;}

  my $name  = "$start_path/$data_dir/$des_file";
  if (!-e $name || -d $name) {return;}

  if ($p ne ''){
     $top = -1;
  }
  else {
     $top = 1;
  }

  my @items = &parse_fields_file ($top, $des_file);

  line: foreach $it (@items) {
 #    next line if ($it->{'ACTIVE'} != 1);
     $key = $it->{'KEY'};

     if ($top > 0) {
        $path = $key;
     }
     else {
        $path = "$p/$key";
     }

     &fix_field ($it, $path, ($top > 0), 0);

     $fields_dir = "dir_$key" if ($top > 0);
     $desfile = $it->{"DESC_FILE"};
     $name  = "$start_path/$data_dir/$desfile";

     if (-e $name && !-d $name) {
        @tmp = (@tmp, "<p><ul><strong>");
        @tmp = (@tmp,  &get_cp_data ($path, $it, $fields_dir, "black", 0, $cpanel));
        @tmp = (@tmp, "</strong><br>\n");
        @tmp = (@tmp,  &visit_all ($path, $desfile, $field_dir), "</ul>\n", );
     } 
     else {
        if ($top < 0) {
           @tmp = (@tmp, "<br><li>\n");
        }
        else {
           @tmp = (@tmp, "<p><ul><strong>");
        }

        @tmp = (@tmp, &get_cp_data ($path, $it, $fields_dir, "black", 0, $cpanel));
        @tmp = (@tmp, "</strong></ul>\n") if ($top > 0);
     }
  }   

  return @tmp;
}


###########################################################################
sub process_keys_search {
###########################################################################
  my ($p, $des_file, $fields_dir) = @_;

  my @tmp = ();
  my @keys = ();
  my $key;
  my $top;
  my $it;
  my $desfile;
  my $path;

  if (!$des_file  || $des_file eq '') {return;}

  my $name  = "$start_path/$data_dir/$des_file";
  if (!-e $name || -d $name) {return;}

  if ($p ne ''){
     $top = -1;
  }
  else {
     $top = 1;
  }

  my @items = &parse_fields_file ($top, $des_file);

  line: foreach $it (@items) {
     next line if ($it->{'ACTIVE'} != 1);

     $key = $it->{'KEY'};

     if ($top > 0) {
        $path = $key;
     }
     else {
        $path = "$p/$key";
     }

     &fix_field ($it, $path, ($top > 0), 0);
     $fields_dir = "dir_$key" if ($top > 0);

     $desfile = $it->{"DESC_FILE"};
     $name  = "$start_path/$data_dir/$desfile";

     if (-e $name && !-d $name) {
        @tmp = (@tmp, &search_in_file ($path, $fields_dir , $it));
        @tmp = (@tmp, &search_in_pages ($path, $fields_dir , $it));
        @tmp = (@tmp, &process_keys_search ($path, $desfile, $field_dir));
     }
  }   

  return @tmp;
}

###########################################################################
sub search_in_file {
###########################################################################
   my ($path, $field_dir, $item) = @_;

   my @tmp = ();
   my $f_n = '';
   my @data = ();
   my $hits = '';
   my $name;
  
   $name = $item->{'INDEX_FILE'};

   if (!$name || $name eq '') {return;}

   $f_n = "$field_dir_base/$field_dir/$name";

   if (!-e $f_n || -d $f_n ) {
     return;
   }

   if (open(F, $f_n))
   {
      @data = <F>;
      $hits = grep(/$query/i, @data);
      close F;

      if ($hits) {
         push @tmp, "\n<p><li> ";
         push @tmp, "<a href=http://$SITE_IP/$index/$path>* $item->{'NAME'}</a><br>\n";
      }
   }

   return @tmp;
}

###########################################################################
sub search_in_pages {
###########################################################################
   my ($path, $field_dir, $item) = @_;
   my @tmp = ();
   my $f_n = '';
   my @data = ();
   my $count = 0;
   my $hits = '';

   my $name = $item->{'INDEX_FILE'};
   my $pg = $item->{'PAGES'};

   if (!$name || $name eq '') {return;}
   if (!$pg || $pg eq '' || $pg < 0) {return;}

   while ($count = $pg) {
       my ($fname, $ext) = split (/\./, $name, 2);

       $fname = $fname."_".$count.".html";
       $f_n = "$field_dir_base/$field_dir/$fname";
       $hits = '';
   
       if (-e $f_n  && !-d $f_n) { 
        
          if (open(F, "$f_n"))
          { 
             @data = <F>;
             $hits = grep(/$query/i, @data);
             close F;
   
             if ($hits) {
                push @tmp, "<a href=http://$SITE_IP/$index/$path?page=$count>* $item->{'NAME'}, page $count</a><br>\n";
                push @tmp, "<font size=-1>$hits</font>\n<br>\n"
             }
          }
       }
       $count++;
   }

   return @tmp;
}

