{
'success';
}

###########################################################################
sub debug_print_hash () {
###########################################################################
  my $hash  = shift;
  my $ret;

  $ret = "\n-- HASH:\n";

  while (my($k,$v) = each %$hash) {
      $ret .= "$k => $v\n";
  }

  $ret .= "-- END OF HASH\n\n";
  return $ret;
}

###########################################################################
sub debug_print_list () {
###########################################################################
  my $list  = shift;
  my $ii;
  my $ret;

  $ret = "\n-- LIST :\n";
  foreach $ii (@$list) {
      $ret .= "$ii\n";
  }

  $ret .= "-- END OF LIST\n\n";
  return $ret;
}

###########################################################################
sub debug_print_list_of_hash () {
###########################################################################
  my $list  = shift;
  my $ii;
  my $ret;

  $ret = "\n-- LIST of hash:\n";
  foreach $ii (@$list) {
      $ret .= &debug_print_hash ($ii);
  }

  $ret .= "-- END OF LIST of hash\n\n";
  return $ret;
}


###########################################################################
sub debug_print_item () {
###########################################################################
  my $item  = shift;
  my $ret;

  $up_list      = $item->{'UP_LIST'};
  $up           = $item->{'UP_HASH'};
  $hash         = $item->{'HASH'};
  $level        = $item->{'LEVEL'};
  $down_list    = $item->{'DOWN_LIST'};
  $has_ch       = $item->{'HAS_CH'};

  if (defined $up_list) { 
     $ret .= "UPLIST ------- :\n";
     $ret .= &debug_print_list_of_hash ($up_list);
  }
  else { $ret .= "up_list not defined"; }

  $ret .= "\n";

  if (defined $up) { 
     $ret .= " UP item  --------: \n";
  }
  else { $ret .= "up not defined"; }

  $ret .= "\n";
  
  if (defined $hash) {
     $ret .= " MAIN HASH --------: \n";
     $ret .= &debug_print_hash ($hash); 
  }
  else { $ret .= "hash not defined"; }

  $ret .= "\n";
  
  if (defined $level) { $ret .= "level --------: = $level"; }
  else { $ret .= "level not defined"; }

  $ret .= "\n";
  
  if (defined $down_list) { 
     $ret .= "DOWNLIST ------- :\n";
     $ret .= &debug_print_list_of_hash ($down_list); 
  }
  else { $ret .= "down_list not defined"; }

  $ret .= "\n";
  
  if (defined $has_ch) { $ret .= "has children --------: = $has_ch"; }
  else { $ret .= "has_ch not defined"; }

  $ret .= "\n";
  return $ret;
}

 
